package algorithms;

import java.util.HashSet;
import java.util.Set;

import graph.AdjacencyMatrixGraph;
import graph.ListColoredAdjacencyMatrixGraph;

public class ReductionRules {
	Solver s;
	ListColoredAdjacencyMatrixGraph query;
	AdjacencyMatrixGraph host;
	Set<Integer> reduced;
	final boolean verbose = false;
	public ReductionRules(Solver s){
		this.s = s;
		this.query = s.g;
		this.host = s.h;
		reduced = new HashSet<Integer>();   //contains a set of vertices for which a rule has been applied
	}
	
	public void reduceInstance(){
		//Find vertices that have only one destination ---> reduce accordingly
		int uniqueVert = hasUniqueMatch();
		
		while (uniqueVert>=0){
			if (verbose) System.out.println("applying reduction rules");
			reduced.add(uniqueVert);
			int c = query.getList(uniqueVert).iterator().next();
			for (int i=0; i<query.vertexNum();i++){				
				if (i!=uniqueVert && query.getList(i).contains(c)){
					query.getList(i).remove(c);
				}
			}
			uniqueVert = hasUniqueMatch();
		}

	}
	
	private int hasUniqueMatch(){
		for (int i=0; i<query.vertexNum();i++){
			if (query.getList(i).size()==1 && !reduced.contains(i)) return i;
		}
		return -1;
	}
	
}
