package graph;
import java.util.*;
import java.io.*;

public class ListColoredAdjacencyMatrixGraph extends AdjacencyMatrixGraph{
	private ColorList listColors;
	
	public void addColorList(ColorList cl){
		this.listColors = cl;
	}
	
	public ListColoredAdjacencyMatrixGraph(File f){
		super(f);
	}
	
	public ListColoredAdjacencyMatrixGraph(int n, int m){
		super(n,m);
	}
	
	public ListColoredAdjacencyMatrixGraph(int n){
		super(n);
	}
	
	public ListColoredAdjacencyMatrixGraph(int n, double p){
		super(n,p);
	}
	
	public ColorList getColorList(){
		return this.listColors;
	}
	
	public Set<Integer> getList(int i){
		return this.listColors.getList(i);
	}
	
	public Set<Integer> setList(int i, Set<Integer> list){
		return this.listColors.setList(i,list);
	}
	
	public ListColoredAdjacencyMatrixGraph inducedGraphVertexDel(Set<Integer> del){
		ListColoredAdjacencyMatrixGraph h = new ListColoredAdjacencyMatrixGraph(this.vertexNum()-del.size());
		h.listColors = new ColorList();
		int deleted=0;
		Map<Integer,Integer> newToOld = new HashMap<Integer, Integer>();
		for (int i =0;i<this.vertexNum();i++){
			if (del.contains(i)){
				deleted++;				
			}
			else {
				newToOld.put(i-deleted, i);
			}
		}
		//create new string maps
		HashMap<Integer, String> newBackMap = new HashMap<Integer, String>();
		HashMap<String, Integer> newStringMap = new HashMap<String, Integer>();
		for (int i =0;i<h.vertexNum();i++){
			//insert into new string maps
			newStringMap.put(this.getVertexString(newToOld.get(i)),i);
			newBackMap.put(i, this.getVertexString(newToOld.get(i)));
			h.setList(i, this.getList(newToOld.get(i)));
			//create new adjacencies
			for (int j =i+1;j<h.vertexNum();j++){
				int u = newToOld.get(i).intValue();
				int v = newToOld.get(j).intValue();
				if (this.areAdjacent(u, v))  h.insertEdge(i,j);
			}
		}
		h.setBackMap(newBackMap);
		h.setStringMap(newStringMap);
		return h;
	}	
}
