package importer;

import java.io.*;

public class OutWriter {
	private static int fileId = 1;
	private FileWriter fstream; 
	private BufferedWriter out;
	private final String[] tableHead = {"Complex Name","Complex Proteins","Matching Subcomplex","Candidates","Matchings","Running Time"};
	private String currentLine;
	private String path;
	
	public OutWriter (String filename){
		this.path = filename;
			try {
				this.fstream = new FileWriter(filename);
			} catch (IOException e) {
				this.fstream = null;
				e.printStackTrace();
			}
			out = new BufferedWriter(fstream);
	}
	
	public void write(String line){
		try {
			out.write(line);
			out.write("\n");
		} catch (IOException e) {
			e.printStackTrace();
		}
	}
	
	public void writeTabs(String[] columns){
		String line = "";
		for (int i=0;i<columns.length-1;i++){
			line += columns[i]+"\t";
		}
		line += columns[columns.length-1];
		this.write(line);
	}
	
	public void printTableHead(){
		this.writeTabs(tableHead);
	}
	
	public void addToCurrentLine(String tab){
		currentLine += tab+"\t";
	}
	
	public void writeCurrentLine(){
		write(currentLine.trim());
		currentLine = "";
	}
	
	public void close(){
		try {
			out.close();
		} catch (IOException e) {
			e.printStackTrace();
		}
	}
	
	public String getFileName(){
		return path;
	}
	
	public static OutWriter temporaryOut(){
		String tmpdir = "";
		OutWriter out = new OutWriter(tmpdir + fileId +".tmp");
		fileId++;
		//System.out.println(fileId);
		return out;
	}
	
}
